#include "math.h"
#include "extdll.h"
#include "enginecallback.h"
#include "util.h"
#include "cbase.h"
#include "player.h"
#include "weapons.h"
#include "entity_state.h"
#include "dll.h"
#include "engine.h"
#include "basemonster.h"

#include "dropgun.h"

int precached_models[256];
int precached_sounds[256];

modcmd_t ModCmd;

int Features;

char FSNTFVersion[32];

float NextCvarCheck;
float timed_messages_next;

float NextEntityCheck;

int TeamAlly[4];

cvar_t fs_dropgun = {"fs_dropgun","1"};

void FSGameDLLInit()
{
	CVAR_REGISTER(&fs_dropgun);
}

int FSPlayerPreThink(edict_t *pEntity)
{
	// Don't do weird shit to non connected players
    if(FStrEq(STRING(pEntity->v.netname),"") || (!FStrEq(STRING(pEntity->v.classname),"player")))
		return 0;

	int hasweap = 0;
	for ( int i = 1; i <= 23; i++ )		
		{
			if(pEntity->v.weapons & (1<<i))
			{
				hasweap = 1;
			}
		}
	if(!hasweap)
	{
	pEntity->v.viewmodel = 0;
	pEntity->v.weaponmodel = 0;
	}
    // Add player abilities based on range form another player type

  	return 0;
}

int FSPlayerPostThink(edict_t *pEntity)
{
	return 0;
}

int FSDispatchKeyValue(edict_t *pEntity, KeyValueData *pkvd)
{
	return 0;
}

int FSDispatchThink(edict_t *pEntity)
{
	if(FStrEq(STRING(pEntity->v.classname), "droppedgun"))
	{
	return GunThink(pEntity);
	}
	return 0;
}
bool GunThink(edict_t *pEntity)
{
	int counter;
	for(counter=1; counter <= gpGlobals->maxClients; counter++)
   {
   	CBaseEntity *pCEntity = UTIL_PlayerByIndex(counter);
       if(pCEntity != NULL)
       {
       	if(FVisible(pEntity->v.origin, ENT(pCEntity->pev)) && ((pEntity->v.origin - pCEntity->pev->origin).Length() < 50))
           {
				edict_t	*pWeapon;

				int istr = pEntity->v.netname;

				pWeapon = CREATE_NAMED_ENTITY(istr);
				if (pWeapon != NULL)
				{
					pWeapon->v.origin = pEntity->v.origin;
					pWeapon->v.spawnflags |= SF_NORESPAWN;
					DispatchSpawn( pWeapon );
					DispatchTouch( pWeapon, pCEntity->edict() );
					pCEntity->pev->weapons |= (1<<pEntity->v.iuser1);
				}
				pEntity->v.flags |= FL_KILLME;
			}
       }
   }
	pEntity->v.nextthink = gpGlobals->time;
	return 0;
}
int FSDispatchUse(edict_t *pEntity, edict_t *pOther)
{
    return 0;
}

int FSDispatchTouch(edict_t *pEntity, edict_t *pOther)
{
	return 0;
}

int FSDispatchBlocked(edict_t *pEntity, edict_t *pOther)
{
	return 0;
}


int FSClientCommand(edict_t *pEntity)
{
	if(Features & FEAT_ACTIVE)FSDropGun(pEntity);
    return 0;
}

int FSClientPutInServer(edict_t *pEntity)
{
	return 0;
}


int FSDispatchSpawn(edict_t *pEntity)
{
	CBaseEntity *pCEntity;

	NextCvarCheck = gpGlobals->time;
    NextEntityCheck = gpGlobals->time;
	timed_messages_next = gpGlobals->time;

	if (FStrEq(STRING(pEntity->v.classname), "worldspawn"))
	{
	    Features = FEAT_NONE;

   		precached_models[0] = PRECACHE_MODEL("sprites/laserbeam.spr"); 
        precached_models[3] = PRECACHE_MODEL("sprites/lgtning.spr"); 
        precached_models[4] = PRECACHE_MODEL ("sprites/bubble.spr");
    }
    return 0;
}

int FSClientDisconnect(edict_t *pEntity)
{
		return 0;
}


void FSClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[ 128 ]  )
{
	CLIENT_PRINTF( pEntity, print_console, "\n\nThis server is running AusIV's Dropgun Mini-Mod\nType 'dropgun' in console to throw your weapon.\n");
}

int FSStartFrame(void)
{
	if(gpGlobals->time > NextCvarCheck)
    {
    	int OldFeatures = Features;
    	Features = FEAT_NONE;
		Features |= CVAR_GET_FLOAT("fs_dropgun") ? FEAT_ACTIVE : 0;
//	    Features |= CVAR_GET_FLOAT("ntf_feature_spychat") ? FEAT_SPYCHAT : 0;
    	NextCvarCheck = gpGlobals->time + 10;
    }

    if(gpGlobals->time > NextEntityCheck)
    {
    }
    
	return 0;
}
void FSDropGun(edict_t *pEntity)
{
	if(FStrEq(Cmd_Argv(0), "dropgun"))
	{
		int hasweap = 0;
		for ( int i = 1; i <= 23; i++ )		
		{
			if(pEntity->v.weapons & (1<<i))
			{
				hasweap = 1;
			}
		}
		if(hasweap)
		{
			EMIT_SOUND(pEntity, CHAN_ITEM, "items/ammopickup1.wav", 1, ATTN_NORM);
	 		edict_t *pWeapon;
			pWeapon = CREATE_NAMED_ENTITY(MAKE_STRING("info_target"));
			DispatchSpawn(pWeapon);
			pWeapon->v.origin =pEntity->v.origin + Vector(0, -25, -25);
			pWeapon->v.angles = pEntity->v.v_angle;
			pWeapon->v.angles.x = 0;
			pWeapon->v.angles.z = 0;
			UTIL_MakeVectors(pEntity->v.v_angle);
			pWeapon->v.velocity = pEntity->v.velocity * 0.5 + gpGlobals->v_forward * 256 + Vector(0,0,128);
			pWeapon->v.euser1 = pEntity;
			pWeapon->v.owner = pEntity;
			pWeapon->v.takedamage = DAMAGE_YES;
			pWeapon->v.health = 100000;
			pWeapon->v.movetype = MOVETYPE_TOSS;
			pWeapon->v.solid = SOLID_BBOX;
			pWeapon->v.team = pEntity->v.team;
			pWeapon->v.nextthink = gpGlobals->time + 1;
			UTIL_SetSize(VARS(pWeapon), Vector(-16, -16, 0), Vector(16, 16, 16));
			pWeapon->v.classname = MAKE_STRING("droppedgun");
			//Flamethrower
			if(FStrEq(STRING(pEntity->v.viewmodel), "models/v_flame.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_egon.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_flamethrower");
				pEntity->v.weapons &= ~(1<<13);
				pWeapon->v.iuser1 = 13;
			}
			//Grenade Launcher/Pipe Launcher
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_glauncher.mdl"))
			{
				if(pEntity->v.weapons & (1<<12))
				{
				SET_MODEL(pWeapon, "models/p_glauncher.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_gl");
				pEntity->v.weapons &= ~(1<<12);
				pWeapon->v.iuser1 = 12;
				}
				else
				{
				SET_MODEL(pWeapon, "models/p_glauncher.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_pl");
				pEntity->v.weapons &= ~(1<<22);
				pWeapon->v.iuser1 = 22;
				}
			}
			//Knife
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_knife.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_knife.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_knife");
				pEntity->v.weapons &= ~(1<<23);
				pWeapon->v.iuser1 = 23;
			}
			//Medikit
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_medkit.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_medkit.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_medikit");
				pEntity->v.weapons &= ~(1<<3);
				pWeapon->v.iuser1 = 3;
			}
			//AC
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_mini.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_mini.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_ac");
				pEntity->v.weapons &= ~(1<<17);
				pWeapon->v.iuser1 = 17;
			}
			//NG
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_nailgun.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_nailgun.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_ng");
				pEntity->v.weapons &= ~(1<<10);
				pWeapon->v.iuser1 = 10;
			}
			//SNG
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_snailgun.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_snailgun.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_superng");
				pEntity->v.weapons &= ~(1<<11);
				pWeapon->v.iuser1 = 11;
			}
			//Sniperrifle/autorifle
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_sniper.mdl"))
			{
				if(pEntity->v.weapons & (1<<6))
				{
				SET_MODEL(pWeapon, "models/p_sniper.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_sniperrifle");
				pEntity->v.weapons &= ~(1<<6);
				pWeapon->v.iuser1 = 6;
				}
				else
				{
				SET_MODEL(pWeapon, "models/p_sniper.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_autorifle");
				pEntity->v.weapons &= ~(1<<7);
				pWeapon->v.iuser1 = 7;
				}
			}
			//Spanner
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_spanner.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_spanner.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_spanner");
				pEntity->v.weapons &= ~(1<<4);
				pWeapon->v.iuser1 = 4;
			}
			//Umbrella
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_umbrella.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_crowbar.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_axe");
				pEntity->v.weapons &= ~(1<<5);
				pWeapon->v.iuser1 = 5;
			}
			//Crowbar
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_crowbar.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_crowbar.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_axe");
				pEntity->v.weapons &= ~(1<<5);
				pWeapon->v.iuser1 = 5;
			}
			//Railgun
			if(FStrEq(STRING(pEntity->v.viewmodel), "models/v_tfc_railgun.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_9mmhandgun.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_railgun");
				pEntity->v.weapons &= ~(1<<21);
				pWeapon->v.iuser1 = 21;
			}
			//Tranq
			if(FStrEq(STRING(pEntity->v.viewmodel), "models/v_tfc_pistol.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_spygun.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_tranq");
				pEntity->v.weapons &= ~(1<<20);
				pWeapon->v.iuser1 = 20;
			}
			//RPG
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_srpg.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_srpg.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_rpg");
				pEntity->v.weapons &= ~(1<<14);
				pWeapon->v.iuser1 = 14;
			}
			//ic
			if(FStrEq(STRING(pEntity->v.weaponmodel), "models/p_rpg.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_rpg.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_ic");
				pEntity->v.weapons &= ~(1<<15);
				pWeapon->v.iuser1 = 15;
			}
			//Supershotgun
			if(FStrEq(STRING(pEntity->v.viewmodel), "models/v_tfc_shotgun.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_shotgun.mdl");
				pWeapon->v.netname = MAKE_STRING("tf_weapon_supershotgun");
				pEntity->v.weapons &= ~(1<<9);
				pWeapon->v.iuser1 = 9;
			}
			//Shotgun
			if(FStrEq(STRING(pEntity->v.viewmodel), "models/v_tfc_12gauge.mdl"))
			{
				SET_MODEL(pWeapon, "models/p_shotgun.mdl");

				pWeapon->v.netname = MAKE_STRING("tf_weapon_shotgun");
				pEntity->v.weapons &= ~(1<<8);
				pWeapon->v.iuser1 = 8;
			}
			hasweap = 0;
			for ( int i = 1; i <= 23; i++ )		
			{
				if(pEntity->v.weapons & (1<<i))
				{
					hasweap = 1;
				}
			}
			if(hasweap)
			{
				CLIENT_COMMAND(pEntity, "invprev;wait;+attack;wait;-attack;");
			}
			else
			{
				CLIENT_COMMAND(pEntity, "tf_weapon_axe;tf_weapon_medikit;tf_weapon_spanner;tf_weapon_knife;");
			}
        }
	}
}
